#ifndef _H_7458997E6C6B419A95331D748AD170E3_BehaviorTreeLog_DCPS_H_
#define _H_7458997E6C6B419A95331D748AD170E3_BehaviorTreeLog_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BehaviorTreeLog_.h"


namespace nav2_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class BehaviorTreeLog_TypeSupportInterface;

            typedef BehaviorTreeLog_TypeSupportInterface * BehaviorTreeLog_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BehaviorTreeLog_TypeSupportInterface> BehaviorTreeLog_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BehaviorTreeLog_TypeSupportInterface> BehaviorTreeLog_TypeSupportInterface_out;


            class BehaviorTreeLog_DataWriter;

            typedef BehaviorTreeLog_DataWriter * BehaviorTreeLog_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BehaviorTreeLog_DataWriter> BehaviorTreeLog_DataWriter_var;
            typedef DDS_DCPSInterface_out < BehaviorTreeLog_DataWriter> BehaviorTreeLog_DataWriter_out;


            class BehaviorTreeLog_DataReader;

            typedef BehaviorTreeLog_DataReader * BehaviorTreeLog_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BehaviorTreeLog_DataReader> BehaviorTreeLog_DataReader_var;
            typedef DDS_DCPSInterface_out < BehaviorTreeLog_DataReader> BehaviorTreeLog_DataReader_out;


            class BehaviorTreeLog_DataReaderView;

            typedef BehaviorTreeLog_DataReaderView * BehaviorTreeLog_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BehaviorTreeLog_DataReaderView> BehaviorTreeLog_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BehaviorTreeLog_DataReaderView> BehaviorTreeLog_DataReaderView_out;

            struct BehaviorTreeLog_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < BehaviorTreeLog_, struct BehaviorTreeLog_Seq_uniq_> BehaviorTreeLog_Seq;
            typedef DDS_DCPSSequence_var < BehaviorTreeLog_Seq> BehaviorTreeLog_Seq_var;
            typedef DDS_DCPSSequence_out < BehaviorTreeLog_Seq> BehaviorTreeLog_Seq_out;

            class  BehaviorTreeLog_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BehaviorTreeLog_TypeSupportInterface_ptr _ptr_type;
                typedef BehaviorTreeLog_TypeSupportInterface_var _var_type;

                static BehaviorTreeLog_TypeSupportInterface_ptr _duplicate (BehaviorTreeLog_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BehaviorTreeLog_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BehaviorTreeLog_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BehaviorTreeLog_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BehaviorTreeLog_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BehaviorTreeLog_TypeSupportInterface () {};
                ~BehaviorTreeLog_TypeSupportInterface () {};
            private:
                BehaviorTreeLog_TypeSupportInterface (const BehaviorTreeLog_TypeSupportInterface &);
                BehaviorTreeLog_TypeSupportInterface & operator = (const BehaviorTreeLog_TypeSupportInterface &);
            };

            class  BehaviorTreeLog_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BehaviorTreeLog_DataWriter_ptr _ptr_type;
                typedef BehaviorTreeLog_DataWriter_var _var_type;

                static BehaviorTreeLog_DataWriter_ptr _duplicate (BehaviorTreeLog_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BehaviorTreeLog_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BehaviorTreeLog_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BehaviorTreeLog_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BehaviorTreeLog_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BehaviorTreeLog_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BehaviorTreeLog_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BehaviorTreeLog_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BehaviorTreeLog_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BehaviorTreeLog_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BehaviorTreeLog_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BehaviorTreeLog_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BehaviorTreeLog_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BehaviorTreeLog_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BehaviorTreeLog_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BehaviorTreeLog_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BehaviorTreeLog_& instance_data) = 0;

            protected:
                BehaviorTreeLog_DataWriter () {};
                ~BehaviorTreeLog_DataWriter () {};
            private:
                BehaviorTreeLog_DataWriter (const BehaviorTreeLog_DataWriter &);
                BehaviorTreeLog_DataWriter & operator = (const BehaviorTreeLog_DataWriter &);
            };

            class  BehaviorTreeLog_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BehaviorTreeLog_DataReader_ptr _ptr_type;
                typedef BehaviorTreeLog_DataReader_var _var_type;

                static BehaviorTreeLog_DataReader_ptr _duplicate (BehaviorTreeLog_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BehaviorTreeLog_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BehaviorTreeLog_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BehaviorTreeLog_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BehaviorTreeLog_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BehaviorTreeLog_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BehaviorTreeLog_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BehaviorTreeLog_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BehaviorTreeLog_& instance) = 0;

            protected:
                BehaviorTreeLog_DataReader () {};
                ~BehaviorTreeLog_DataReader () {};
            private:
                BehaviorTreeLog_DataReader (const BehaviorTreeLog_DataReader &);
                BehaviorTreeLog_DataReader & operator = (const BehaviorTreeLog_DataReader &);
            };

            class  BehaviorTreeLog_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BehaviorTreeLog_DataReaderView_ptr _ptr_type;
                typedef BehaviorTreeLog_DataReaderView_var _var_type;

                static BehaviorTreeLog_DataReaderView_ptr _duplicate (BehaviorTreeLog_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BehaviorTreeLog_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BehaviorTreeLog_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BehaviorTreeLog_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BehaviorTreeLog_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BehaviorTreeLog_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BehaviorTreeLog_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BehaviorTreeLog_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BehaviorTreeLog_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BehaviorTreeLog_& instance) = 0;

            protected:
                BehaviorTreeLog_DataReaderView () {};
                ~BehaviorTreeLog_DataReaderView () {};
            private:
                BehaviorTreeLog_DataReaderView (const BehaviorTreeLog_DataReaderView &);
                BehaviorTreeLog_DataReaderView & operator = (const BehaviorTreeLog_DataReaderView &);
            };
        }

    }

}

#endif
