#ifndef _H_8649AC810921D94ACE28222A07B2C69D_BehaviorTreeStatusChange_DCPS_H_
#define _H_8649AC810921D94ACE28222A07B2C69D_BehaviorTreeStatusChange_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BehaviorTreeStatusChange_.h"


namespace nav2_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class BehaviorTreeStatusChange_TypeSupportInterface;

            typedef BehaviorTreeStatusChange_TypeSupportInterface * BehaviorTreeStatusChange_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BehaviorTreeStatusChange_TypeSupportInterface> BehaviorTreeStatusChange_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BehaviorTreeStatusChange_TypeSupportInterface> BehaviorTreeStatusChange_TypeSupportInterface_out;


            class BehaviorTreeStatusChange_DataWriter;

            typedef BehaviorTreeStatusChange_DataWriter * BehaviorTreeStatusChange_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BehaviorTreeStatusChange_DataWriter> BehaviorTreeStatusChange_DataWriter_var;
            typedef DDS_DCPSInterface_out < BehaviorTreeStatusChange_DataWriter> BehaviorTreeStatusChange_DataWriter_out;


            class BehaviorTreeStatusChange_DataReader;

            typedef BehaviorTreeStatusChange_DataReader * BehaviorTreeStatusChange_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BehaviorTreeStatusChange_DataReader> BehaviorTreeStatusChange_DataReader_var;
            typedef DDS_DCPSInterface_out < BehaviorTreeStatusChange_DataReader> BehaviorTreeStatusChange_DataReader_out;


            class BehaviorTreeStatusChange_DataReaderView;

            typedef BehaviorTreeStatusChange_DataReaderView * BehaviorTreeStatusChange_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BehaviorTreeStatusChange_DataReaderView> BehaviorTreeStatusChange_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BehaviorTreeStatusChange_DataReaderView> BehaviorTreeStatusChange_DataReaderView_out;

            struct BehaviorTreeStatusChange_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < BehaviorTreeStatusChange_, struct BehaviorTreeStatusChange_Seq_uniq_> BehaviorTreeStatusChange_Seq;
            typedef DDS_DCPSSequence_var < BehaviorTreeStatusChange_Seq> BehaviorTreeStatusChange_Seq_var;
            typedef DDS_DCPSSequence_out < BehaviorTreeStatusChange_Seq> BehaviorTreeStatusChange_Seq_out;

            class  BehaviorTreeStatusChange_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BehaviorTreeStatusChange_TypeSupportInterface_ptr _ptr_type;
                typedef BehaviorTreeStatusChange_TypeSupportInterface_var _var_type;

                static BehaviorTreeStatusChange_TypeSupportInterface_ptr _duplicate (BehaviorTreeStatusChange_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BehaviorTreeStatusChange_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BehaviorTreeStatusChange_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BehaviorTreeStatusChange_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BehaviorTreeStatusChange_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BehaviorTreeStatusChange_TypeSupportInterface () {};
                ~BehaviorTreeStatusChange_TypeSupportInterface () {};
            private:
                BehaviorTreeStatusChange_TypeSupportInterface (const BehaviorTreeStatusChange_TypeSupportInterface &);
                BehaviorTreeStatusChange_TypeSupportInterface & operator = (const BehaviorTreeStatusChange_TypeSupportInterface &);
            };

            class  BehaviorTreeStatusChange_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BehaviorTreeStatusChange_DataWriter_ptr _ptr_type;
                typedef BehaviorTreeStatusChange_DataWriter_var _var_type;

                static BehaviorTreeStatusChange_DataWriter_ptr _duplicate (BehaviorTreeStatusChange_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BehaviorTreeStatusChange_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BehaviorTreeStatusChange_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BehaviorTreeStatusChange_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BehaviorTreeStatusChange_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BehaviorTreeStatusChange_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BehaviorTreeStatusChange_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BehaviorTreeStatusChange_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BehaviorTreeStatusChange_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BehaviorTreeStatusChange_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BehaviorTreeStatusChange_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BehaviorTreeStatusChange_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BehaviorTreeStatusChange_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BehaviorTreeStatusChange_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BehaviorTreeStatusChange_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BehaviorTreeStatusChange_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BehaviorTreeStatusChange_& instance_data) = 0;

            protected:
                BehaviorTreeStatusChange_DataWriter () {};
                ~BehaviorTreeStatusChange_DataWriter () {};
            private:
                BehaviorTreeStatusChange_DataWriter (const BehaviorTreeStatusChange_DataWriter &);
                BehaviorTreeStatusChange_DataWriter & operator = (const BehaviorTreeStatusChange_DataWriter &);
            };

            class  BehaviorTreeStatusChange_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BehaviorTreeStatusChange_DataReader_ptr _ptr_type;
                typedef BehaviorTreeStatusChange_DataReader_var _var_type;

                static BehaviorTreeStatusChange_DataReader_ptr _duplicate (BehaviorTreeStatusChange_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BehaviorTreeStatusChange_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BehaviorTreeStatusChange_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BehaviorTreeStatusChange_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BehaviorTreeStatusChange_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BehaviorTreeStatusChange_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BehaviorTreeStatusChange_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BehaviorTreeStatusChange_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BehaviorTreeStatusChange_& instance) = 0;

            protected:
                BehaviorTreeStatusChange_DataReader () {};
                ~BehaviorTreeStatusChange_DataReader () {};
            private:
                BehaviorTreeStatusChange_DataReader (const BehaviorTreeStatusChange_DataReader &);
                BehaviorTreeStatusChange_DataReader & operator = (const BehaviorTreeStatusChange_DataReader &);
            };

            class  BehaviorTreeStatusChange_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BehaviorTreeStatusChange_DataReaderView_ptr _ptr_type;
                typedef BehaviorTreeStatusChange_DataReaderView_var _var_type;

                static BehaviorTreeStatusChange_DataReaderView_ptr _duplicate (BehaviorTreeStatusChange_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BehaviorTreeStatusChange_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BehaviorTreeStatusChange_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BehaviorTreeStatusChange_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BehaviorTreeStatusChange_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BehaviorTreeStatusChange_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BehaviorTreeStatusChange_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BehaviorTreeStatusChange_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BehaviorTreeStatusChange_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BehaviorTreeStatusChange_& instance) = 0;

            protected:
                BehaviorTreeStatusChange_DataReaderView () {};
                ~BehaviorTreeStatusChange_DataReaderView () {};
            private:
                BehaviorTreeStatusChange_DataReaderView (const BehaviorTreeStatusChange_DataReaderView &);
                BehaviorTreeStatusChange_DataReaderView & operator = (const BehaviorTreeStatusChange_DataReaderView &);
            };
        }

    }

}

#endif
